*=============================================================================
*!Locked by : Wietse Dol (w.dol@wur.nl)
*!Lock date : 27-Oct-10 8:51:33
*! <%GTREECONTROL SkipFile%>
* We define here the sets and parameters we need for Tree aggregations and Tree
* functions we can use on Tree Sets (Classifications like NUTS regions, HS or CN products etc.)

*NB: the maximum depth of the tree is set to 256 (increasing it is no problem, the code is generic)
*===========================================================================================
$if defined PClevels $exit

set AggregateType/Original,Aggregated,Missing,Difference/;

set PClevels/level256*level1/;

parameter CurLevelCount(PClevels) "Number of elements per tree level";

scalar CheckEmptyChildren;
CheckEmptyChildren=1;

$if not defined P_PClevels alias(PClevels,P_PClevels);
set Reverse_PClevels(pclevels,p_pclevels);
Reverse_PClevels(PClevels,pclevels+[card(pclevels)-2*ord(pclevels)+1]) = yes;

%display% "Loaded set: AggregateType -> used to show differences in tree aggregation methods"
%display% "Loaded set: PClevels -> Level in Parent Child table of the tree"
%display% "Created parameter: CurLevelCount -> Number of elements per tree level"
*===========================================================================================
